com.io7m.r2.filters

## Interface R2FilterBilateralBlurDepthAwareParametersType<SD extends R2RenderTargetDescriptionType,S extends R2RenderTargetUsableType<SD>,DD extends R2RenderTargetDescriptionType,D extends R2RenderTargetUsableType<DD>>

- Type Parameters:
    `SD` - The type of source render target descriptions
    `S` - The type of source render targets
    `DD` - The type of destination render target descriptions
    `D` - The type of destination render targets
  All Known Implementing Classes:
    R2FilterBilateralBlurDepthAwareParameters

      public interface R2FilterBilateralBlurDepthAwareParametersType<SD extends R2RenderTargetDescriptionType,S extends R2RenderTargetUsableType<SD>,DD extends R2RenderTargetDescriptionType,D extends R2RenderTargetUsableType<DD>>

  Parameters for bilateral blur filters that blur render targets of type `S` and write the blurred results to render targets of type `T`.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default R2BilateralBlurParameters` | `blurParameters()`
    `R2Texture2DUsableType` | `depthTexture()`
    `BiFunction<DD,com.io7m.jareas.core.AreaInclusiveUnsignedLType,DD>` | `outputDescriptionScaler()`
    `D` | `outputRenderTarget()`
    `Function<D,R2Texture2DUsableType>` | `outputTextureSelector()`
    `R2RenderTargetPoolUsableType<DD,D>` | `renderTargetPool()`
    `R2MatricesObserverValuesType` | `sceneObserverValues()`
    `S` | `sourceRenderTarget()`
    `Function<S,R2Texture2DUsableType>` | `sourceTextureSelector()`

- - ### Method Detail

    - #### sourceRenderTarget

          S sourceRenderTarget()

      Returns:
        The source render target

    - #### sourceTextureSelector

          Function<S,R2Texture2DUsableType> sourceTextureSelector()

      Returns:
        A function that, given a render target of type `S`, selects which texture on that render target will be used for blurring.

    - #### outputRenderTarget

          D outputRenderTarget()

      Returns:
        The output render target

    - #### outputTextureSelector

          Function<D,R2Texture2DUsableType> outputTextureSelector()

      Returns:
        A function that, given a render target of type `D`, selects which texture on that render target will be used for blurring.

    - #### renderTargetPool

          R2RenderTargetPoolUsableType<DD,D> renderTargetPool()

      Returns:
        A pool used to construct temporary render targets

    - #### outputDescriptionScaler

          BiFunction<DD,com.io7m.jareas.core.AreaInclusiveUnsignedLType,DD> outputDescriptionScaler()

      Returns:
        A function that, given an existing description `D` and an area `A`, returns a new description with the values of `D` and the area `A`.

    - #### sceneObserverValues

          R2MatricesObserverValuesType sceneObserverValues()

      Returns:
        The scene observer values

    - #### depthTexture

          R2Texture2DUsableType depthTexture()

      Returns:
        The depth texture that will be used to control how the blur effect is applied

    - #### blurParameters

          default R2BilateralBlurParameters blurParameters()

      Returns:
        The blur parameters

Copyright © 2017 <code@io7m.com> http://io7m.com